#pragma once
#include <cstdint>
#include <array>
#include <fstream>
#include <iostream>
#include <vector>

struct Node
{
	static uint16_t nst_id;
	uint16_t n_id;
	uint16_t x;
	uint16_t y;
	uint16_t z;
	bool gr;
	Node();
	Node(uint16_t a, uint16_t b, uint16_t c);
	uint16_t operator =(const Node& a)
	{
		return a.n_id;
	}
	friend std::ifstream& operator >>(std::ifstream& os, Node& a);
	friend bool operator <(const Node& a, const Node& b);
	friend bool operator==(const Node& a, const Node& b);
	
};

struct Finite_element
{
	static uint16_t fst_id;
	uint16_t fe_id;
	uint16_t m_id;
	std::vector<uint16_t> nodes;
	Finite_element(uint16_t a, uint16_t b, uint16_t c, uint16_t d, uint16_t mat_id);
	Finite_element();
	friend std::ifstream& operator >>(std::ifstream& os, Finite_element& a);
};

struct Boundary_Finite_element
{
	static uint16_t bst_id;
	uint16_t bfe_id;
	uint16_t g_id;
	std::vector<uint16_t> nodes;
	Boundary_Finite_element();
	Boundary_Finite_element(uint16_t a, uint16_t b, uint16_t c, uint16_t pov_id);
	friend std::ifstream& operator >>(std::ifstream& os, Boundary_Finite_element& a);
};

